# Proposal

Proposals handle consensus for a given transaction, mapped one-to-one. Without a proposal account for a transaction, it can not be voted on and subsequently executed.

### Getting a Proposal account

```typescript
import * as multisig from "@sqds/multisig";

const { Proposal } = multisig.accounts;

async function main() {
    // Public Key of the Multisig PDA
    const multisigPda = new PublicKey("MyAmazingMultisig");
    
    // Fetch the deserialized Multisig account
    const multisigInfo = await multisig.accounts.Multisig.fromAccountAddress(
      connection,
      multisigPda
    );

    // Get the current transaction index
    const currentTransactionIndex = Number(multisigInfo.transactionIndex);
    const transactionIndex = BigInt(currentTransactionIndex + 1);
    // or, if this is your first transaction
    // const transactionIndex = 1n;    
    
    // Bump is generally not needed
    const [proposalPda, proposalBump] = multisig.getProposalPda({
        multisigPda,
        transactionIndex,
    });
    
    const proposalAccount = await Proposal.fromAccountAddress(
        connection,
        proposalPda
    );
          
    // Log the proposal status
    console.log("Proposal Status", proposalAccount.status);
}
```

### Notes

* Required for voting on and executing transactions
* They store status of consensus, and tallies for who's approved and rejected.
* See the [reference](/main/development/reference/accounts.md#proposal) for more information on account structure and seeds.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.squads.so/main/development/typescript/accounts/proposal.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
